#include "OsiClpSolverInterface.hpp"
#include "CoinPackedMatrix.hpp"
#include "CoinPackedVector.hpp"
#include "CoinHelperFunctions.hpp"
#include <iostream>
#include <vector>
using namespace std;

#define tolerance 0.001

/*---------------------------------------------------------------------*/
int main(int argc, char* argv[]){
  
  OsiClpSolverInterface* si_clp = new OsiClpSolverInterface();
  si_clp->readMps("mps6.mps");
  
  const int m = si_clp->getNumRows();  
  si_clp->initialSolve();

  const double * pi1 = si_clp->getRowPrice();
  for(int i = 0; i < m; i++)
    cout << "pi1[" << i << "] : " << pi1[i] << endl;

  //Column Adding:
  /*52a53,57
    >     C0000008  OBJROW    57.            R0000000  2.
    >     C0000008  R0000001  1.             R0000002  4.
    >     C0000008  R0000003  2.             R0000004  2.
    >     C0000008  R0000005  2.             R0000006  1.
    >     C0000008  R0000007  1.*/
     
  CoinPackedVector col;
  col.insert(0,2.0);
  col.insert(1,1.0);
  col.insert(2,4.0);
  col.insert(3,2.0);
  col.insert(4,2.0);
  col.insert(5,2.0);
  col.insert(6,1.0);
  col.insert(7,1.0);

  si_clp->addCol(col, 0.0, si_clp->getInfinity(), 57.0);
  
  //no hint, or do_dual returns primal infeasible
  //si_clp->setHintParam(OsiDoDualInResolve,true);
  si_clp->resolve();

  //mps6PlusCol.mps and mps7.mps are identical
  si_clp->writeMps("mps6PlusCol");

  OsiClpSolverInterface* si_clp2 = new OsiClpSolverInterface();
  si_clp2->readMps("mps7.mps");
  si_clp2->initialSolve();

}
